#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Rechner+.ico
#AutoIt3Wrapper_Allow_Decompile=n
#AutoIt3Wrapper_Res_Description=Rechner+ (Ein verbesserter Taschenrechner)
#AutoIt3Wrapper_Res_Fileversion=1.8.0.1
#AutoIt3Wrapper_Res_LegalCopyright=Thomas Stephan (oscar@elektronik-kurs.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GUIConstants.au3>
#include <GuiListView.au3>
#include <Misc.au3>
#include <String.au3>
#include <GuiEdit.au3>
#include <file.au3>
#include <Date.au3>
#Include <Array.au3>

Dim $gaWaehrung
Dim $gaZahl[17]
Dim $gaMem[4]
Dim $gaContr[5]
Dim $gaOp[12]
Dim $gaZSys[3]
Dim $gaFText1[9]
Dim $gaFText2[10]
Dim $gaEinheit[3]
Dim $gaTaV[3]
$gaTaV[0] = "[0-9ABCDEF]"; erlaubte Tasten (Hexadezimal) 
$gaTaV[1] = "[0-9P]"; erlaubte Tasten (Dezimal), P = Pi


Const $Pi = 3.141592653589793; Pi mit 15 Nachkommastellen (AutoIt hat "blo" 15 Stellen Genauigkeit)

Global $gOperators = "/^*,-(+)  "
Global $gAktiv = 0; Hotkeys (0 = nicht aktiv, 1 = Aktiv)
Global $gZSys = 1; Zahlensystem (0 = Hexadezimal, 1 = Dezimal, 2 = Binr)
Global $gNachkomma = IniRead("Rechner+.ini", "Nachkomma", "gNachkomma", "2"); Anzahl der Nachkommastellen
Global $gDatum = IniRead("Rechner+.ini", "Waehrung", "Datum", _Now()); Datum und Uhrzeit der letzten Aktualisierung

Global $gZiffGr = IniRead("Rechner+.ini", "Zifferngruppierung", "gZiffGr", "1"); Zifferngruppierung (0 = aus, 1 = an)
Global $gOnTop = IniRead("Rechner+.ini", "OnTop", "gOnTop", "1"); Immer im Vordergrund (0 = aus, 1 = an)
Global $gFText1 = IniRead("Rechner+.ini", "Color", "gFText1", "0xE6E6E6")
Global $gFText2 = IniRead("Rechner+.ini", "Color", "gFText2", "0xFFFF80")

Global $gMsg, $gStatus, $gInpTest, $gLErg, $gCheck, $Speicher, $Input, $MenuZiffGr, $gMain, $MenuOnTop, $gGleich
Global $gDFUeSpeed, $gDFUeEinheit, $gDFUeGleich, $gDSpeed, $gErgN, $gWaehrungVon, $gWaehrungNach, $gWHelp
Global $gTausch, $gWaehrungGleich, $gaWAbkHilfe, $gWHA, $WOk, $gWAktDatum

Opt("TrayAutoPause",0)
Opt("GUIOnEventMode", 1)
Break(0)

;************************************************************************************************************************************************************************************
;************************************************************************************************************************************************************************************
$gaWaehrung = IniReadSection("Rechner+.ini", "Waehrungskurse")
If @error Then
	MsgBox(0,"Rechner+", "Ini-Datei fehlt oder fehlerhaft!")
	Exit
EndIf

f_GUICreate(); Funktion zum erstellen des Fensters und der Buttons
f_OnTop($gOnTop); "Immer im Vordergrund"-Funktion aufrufen und entsprechend der Variablen setzen
f_DFUeSpeed()
$gMsg = $gaZSys[1]
f_ZSysClick(); Zahlensystem auf Dezimal stellen
GUISetState(@SW_SHOW); Fenster anzeigen
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
; Hauptschleife
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
While 1; Hauptschleife
		Sleep(100)
		If WinActive("Rechner+") = 1 Then; Wenn Rechner-Fenster aktiv
			If $gAktiv = 0 Then; und vorher nicht aktiv,
				$gAktiv = 1
				f_SetHotkey(); dann die Hotkeys setzen
			EndIf
		Else; Wenn Fenster nicht aktiv
			If $gAktiv = 1 Then; und vorher aktiv,
				$gAktiv = 0
				f_ClearHotKey(); dann die Hotkeys lschen
			EndIf
		EndIf
WEnd
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;---------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Func f_SetHotkey()
	Switch $gZSys; Hotkeys entsprechend dem Zahlensystem setzen
		Case 0; Hexadezimalzahlen
			HotKeySet("{NUMPAD0}", "f_HotKey")
			HotKeySet("{NUMPAD1}", "f_HotKey")
			HotKeySet("{NUMPAD2}", "f_HotKey")
			HotKeySet("{NUMPAD3}", "f_HotKey")
			HotKeySet("{NUMPAD4}", "f_HotKey")
			HotKeySet("{NUMPAD5}", "f_HotKey")
			HotKeySet("{NUMPAD6}", "f_HotKey")
			HotKeySet("{NUMPAD7}", "f_HotKey")
			HotKeySet("{NUMPAD8}", "f_HotKey")
			HotKeySet("{NUMPAD9}", "f_HotKey")
			HotKeySet("{ENTER}", "f_HotKey")
			HotKeySet("{NUMPADDIV}", "f_HotKey")
			HotKeySet("{NUMPADMULT}", "f_HotKey")
			HotKeySet("{NUMPADSUB}", "f_HotKey")
			HotKeySet("{NUMPADADD}", "f_HotKey")
			HotKeySet("{BACKSPACE}", "f_HotKey")
			HotKeySet("{DELETE}", "f_HotKey")
		Case 1; Dezimalzahlen
			HotKeySet("{NUMPAD0}", "f_HotKey")
			HotKeySet("{NUMPAD1}", "f_HotKey")
			HotKeySet("{NUMPAD2}", "f_HotKey")
			HotKeySet("{NUMPAD3}", "f_HotKey")
			HotKeySet("{NUMPAD4}", "f_HotKey")
			HotKeySet("{NUMPAD5}", "f_HotKey")
			HotKeySet("{NUMPAD6}", "f_HotKey")
			HotKeySet("{NUMPAD7}", "f_HotKey")
			HotKeySet("{NUMPAD8}", "f_HotKey")
			HotKeySet("{NUMPAD9}", "f_HotKey")
			HotKeySet("{ENTER}", "f_HotKey")
			HotKeySet("{NUMPADDIV}", "f_HotKey")
			HotKeySet("{NUMPADMULT}", "f_HotKey")
			HotKeySet("{NUMPADSUB}", "f_HotKey")
			HotKeySet("{NUMPADADD}", "f_HotKey")
			HotKeySet("{NUMPADDOT}", "f_HotKey")
			HotKeySet("{BACKSPACE}", "f_HotKey")
			HotKeySet("{DELETE}", "f_HotKey")
		Case 2; Binrzahlen
			HotKeySet("{NUMPAD0}", "f_HotKey")
			HotKeySet("{NUMPAD1}", "f_HotKey")
			HotKeySet("{ENTER}", "f_HotKey")
			HotKeySet("{NUMPADSUB}", "f_HotKey")
			HotKeySet("{NUMPADADD}", "f_HotKey")
			HotKeySet("{BACKSPACE}", "f_HotKey")
			HotKeySet("{DELETE}", "f_HotKey")
	EndSwitch
EndFunc

Func f_ClearHotKey(); Alle Hotkeys lschen
	HotKeySet("{NUMPAD0}")
	HotKeySet("{NUMPAD1}")
	HotKeySet("{NUMPAD2}")
	HotKeySet("{NUMPAD3}")
	HotKeySet("{NUMPAD4}")
	HotKeySet("{NUMPAD5}")
	HotKeySet("{NUMPAD6}")
	HotKeySet("{NUMPAD7}")
	HotKeySet("{NUMPAD8}")
	HotKeySet("{NUMPAD9}")
	HotKeySet("{ENTER}")
	HotKeySet("{NUMPADDIV}")
	HotKeySet("{NUMPADMULT}")
	HotKeySet("{NUMPADSUB}")
	HotKeySet("{NUMPADADD}")
	HotKeySet("{NUMPADDOT}")
	HotKeySet("{BACKSPACE}")
	HotKeySet("{DELETE}")
EndFunc

Func f_MainClose()
	f_ClearHotKey()
	Exit
EndFunc

Func f_ZSysClick(); Zahlensystem auswhlen
	Local $erg, $i
	If $gMsg = 0 Then $gMsg = @GUI_CtrlID
	Switch $gMsg
		Case $gaFText2[0]; ==================== Hexadezimalsystem angeklickt ====================
			ControlFocus("Rechner+", "", $gaZSys[0])
			ControlClick("Rechner+", "", $gaZSys[0])
		Case $gaZSys[0]; ==================== Hexadezimalsystem angeklickt ====================
			$gLErg = ""; Letztes Ergebnis lschen
			GUICtrlSetData($Speicher, 0)
			For $i = 2 To 16
				If $i = 10 Then 
					GUICtrlSetImage($gaZahl[$i], "gfx\d-10.ico"); Pi-Button deaktivieren
				Else
					GUICtrlSetImage($gaZahl[$i], "gfx\e-" & $i & ".ico"); Zahlen aktivieren
				EndIf
			Next
			For $i = 0 To 11
				If $i < 8 Then
					If ($i = 1) Or ($i = 3) Then
						GUICtrlSetImage($gaOp[$i], "gfx\d-op" & $i & ".ico");  [,] und [2^] deaktivieren
					Else
						GUICtrlSetImage($gaOp[$i], "gfx\e-op" & $i & ".ico"); [+] [-] [*] [/] [(] [)] aktivieren
					EndIf
				Else
					GUICtrlSetImage($gaOp[$i], "gfx\d-op" & $i & ".ico"); die anderen Operatoren deaktivieren
				EndIf
			Next
			GUICtrlSetState($gaContr[2], $GUI_DISABLE); Nachkommastellen [up] und [down] deaktivieren
			GUICtrlSetBKColor($gaContr[2], "0XAAAAAA")
			GUICtrlSetImage($gaContr[3], "gfx\d-up.ico")
			GUICtrlSetImage($gaContr[4], "gfx\d-down.ico")
			GUICtrlSetImage($gDFUeGleich, "gfx\d-berechnen.ico")
			GUICtrlSetImage($gWaehrungGleich, "gfx\d-umrechnen.ico")
			GUICtrlSetImage($gTausch, "gfx\d-tauschen.ico")
			Switch $gZSys
				Case 0
					$gZSys = 0; Zahlensystem auf Hexadezimal setzen
					f_ClearHotKey()
					f_SetHotkey()
				Case 1; vorher Dezimal
					$erg = String(Int(f_Auswertung(GUICtrlRead($Input)))); Ergebnis auslesen,
					$gZSys = 0; Zahlensystem auf Hexadezimal setzen
					f_ClearHotKey()
					f_SetHotkey()
					$erg = f_Auswertung(Hex($erg)); umrechnen nach Hex
					If $erg = "0" Then $erg = "" 
					GUICtrlSetData($Input, $erg); und wieder anzeigen
					f_GleichClick()
			EndSwitch
		Case $gaFText2[1]; ==================== Dezimalsystem angeklickt ====================
			ControlFocus("Rechner+", "", $gaZSys[1])
			ControlClick("Rechner+", "", $gaZSys[1])
		Case $gaZSys[1]; ==================== Dezimalsystem angeklickt ====================
			$gLErg = ""; Letztes Ergebnis lschen
			GUICtrlSetData($Speicher, 0)
			For $i = 2 To 16
				If $i < 11 Then
					GUICtrlSetImage($gaZahl[$i], "gfx\e-" & $i & ".ico"); Zahlen und Pi aktivieren
				Else
					GUICtrlSetImage($gaZahl[$i], "gfx\d-" & $i & ".ico"); [A] - [F] deaktivieren
				EndIf
			Next
			For $i = 0 To 11
				GUICtrlSetImage($gaOp[$i], "gfx\e-op" & $i & ".ico"); Operatoren aktivieren
			Next
			GUICtrlSetState($gaContr[2], $GUI_ENABLE); Nachkommastellen [up] und [down] aktivieren
			GUICtrlSetBKColor($gaContr[2], "0XFFFFFF")
			GUICtrlSetImage($gaContr[3], "gfx\e-up.ico")
			GUICtrlSetImage($gaContr[4], "gfx\e-down.ico")
			GUICtrlSetImage($gDFUeGleich, "gfx\e-berechnen.ico")
			GUICtrlSetImage($gWaehrungGleich, "gfx\e-umrechnen.ico")
			GUICtrlSetImage($gTausch, "gfx\e-tauschen.ico")
			Switch $gZSys
				Case 0; Hexadezimal
					$erg = String(f_Auswertung(GUICtrlRead($Input))); Ergebnis auslesen,
					$gZSys = 1; Zahlensystem auf Dezimal setzen
					f_ClearHotKey()
					f_SetHotkey()
					$erg = f_Auswertung(Dec($erg)); umrechnen nach Dezimal
					If $erg = "0" Then $erg = "" 
					GUICtrlSetData($Input, $erg); und wieder anzeigen
					If $erg <> "" Then f_GleichClick()
				Case 1
					$gZSys = 1; Zahlensystem auf Dezimal setzen
					f_ClearHotKey()
					f_SetHotkey()
			EndSwitch
	EndSwitch
	ControlFocus("Rechner+", "", $Input)
	$gMsg = 0
EndFunc

Func f_ZahlClick()
	If $gErgN = 1 Then; Nach Ergebnis -> Neue Rechnung
		$gErgN = 0
		GUICtrlSetData($Input, ""); Eingabefeld lschen
	EndIf
	$gLErg = ""; Letztes Ergebnis lschen
	Local $msg = @GUI_CtrlID; Welche Zahl oder Buchstabe wurde angeklickt?
	Local $tmp = GUICtrlRead($Input)
	Switch $msg
		Case $gaZahl[0] To $gaZahl[9]; Zahlen [0]...[9] 
			If StringRight($tmp, 1) <> "i" Then; Zahl nur einfgen, wenn vorher kein Pi dort steht
				$tmp &= $msg - 4159
				If ($gZiffGr = 1) and ($gZSys = 1) Then; Zifferngruppierung an und Dezimalsystem?
					$tmp = StringReplace($tmp, ".", "")
					$tmp = f_AddPunkt($tmp); dann Punkte setzen
				EndIf
				GUICtrlSetData($Input, $tmp)
			EndIf
		Case $gaZahl[10]; Button [Pi]
			If ($gZSys = 1) and Not (StringRegExp(StringRight($tmp, 1), "[0-9]")) Then GUICtrlSetData($Input, $tmp & "Pi")
		Case $gaZahl[11] To $gaZahl[16]; Buchstaben [A]...[F]
			If $gZSys = 0 Then GUICtrlSetData($Input, $tmp & Chr($msg - 4118))
	EndSwitch
	ControlFocus("Rechner+", "", $Input)
EndFunc

Func f_AddPunkt($Str, $pm = 0)
	$s = StringSplit($Str, " "); Eingabestring teilen
	If $pm = 1 Then; nur bei anklicken von [+/-] Button
		$s[$s[0]] = StringReplace($s[$s[0]], ".", "")
		$s[$s[0]] = StringReplace($s[$s[0]], ",", ".")
		$s[$s[0]] = -$s[$s[0]]; letzten Term invertieren
		$s[$s[0]] = StringReplace($s[$s[0]], ".", ",")
	EndIf
	If $s[0] > 1 Then; Bei mehr als einem Term
		For $i = 1 To $s[0]
			If StringRegExp($s[$i], "[0-9,.]") = 1 Then; Zahl oder Oderator?
				$s[$i] = _StringAddComma($s[$i], ".", ","); Zahl
			Else
				If $s[$i] <> "" Then $s[$i] = " " & $s[$i] & " "; Operator
			EndIf
		Next
		$Str = ""
		For $i = 1 To $s[0]
			$Str &= $s[$i]; Eingabestring wieder zusammenfgen
		Next
	Else
		$Str = _StringAddComma($s[$s[0]], ".", ","); nur ein Term
	EndIf
	Return($Str); Rckgabe 
EndFunc

Func f_MemClick()
	Local $msg = @GUI_CtrlID
	Local $Tmp, $hSp, $hIn 
	Switch $msg
		Case $gaMem[0]; Speicher lschen
			GUICtrlSetData($Speicher, 0)
		Case $gaMem[1]; Speicher in die Anzeige bringen
			$gLErg = ""
			GUICtrlSetData($Input, GUICtrlRead($Input) & GUICtrlRead($Speicher))
		Case $gaMem[2]; vom Speicher subtrahieren
			$hSp = f_Auswertung(GUICtrlRead($Speicher))
			$hIn = f_Auswertung(GUICtrlRead($Input))
			Switch $gZSys
				Case 0; Hexadezimal
					$hSp = "0x" & $hSp; Bei Hex-Zahlen 0x voranstellen
					$hIn = "0x" & $hIn
				Case 2; Binr
			EndSwitch
			$Tmp = String($hSp - $hIn)
			$Tmp = StringReplace($Tmp, ".", ",")
			Switch $gZSys
				Case 0; Hexadezimal
					$Tmp = Hex($Tmp)
					$Tmp = StringReplace($Tmp, "0", " "); Nullen in Leerzeichen umwandeln
					$Tmp = StringStripWS($Tmp, 1); fhrende Leerzeichen (Nullen) entfernen
					$Tmp = StringReplace($Tmp, " ", "0"); Leerzeichen wieder in Nullen wandeln
				Case 1; Dezimal
					If $gZiffGr = 1 Then; Zifferngruppierung an? 
						$Tmp = StringReplace($Tmp, ".", "")
						$Tmp = f_AddPunkt($Tmp); dann Punkte setzen
					EndIf
			EndSwitch
			GUICtrlSetData($Speicher, $Tmp)
		Case $gaMem[3]; zum Speicher addieren
			$hSp = f_Auswertung(GUICtrlRead($Speicher))
			$hIn = f_Auswertung(GUICtrlRead($Input))
			Switch $gZSys
				Case 0; Hexadezimal
					$hSp = "0x" & $hSp; Bei Hex-Zahlen 0x voranstellen
					$hIn = "0x" & $hIn
				Case 2; Binr
			EndSwitch
			$Tmp = String($hSp + $hIn)
			$Tmp = StringReplace($Tmp, ".", ",")
			Switch $gZSys
				Case 0; Hexadezimal
					$Tmp = Hex($Tmp)
					$Tmp = StringReplace($Tmp, "0", " "); Nullen in Leerzeichen umwandeln
					$Tmp = StringStripWS($Tmp, 1); fhrende Leerzeichen (Nullen) entfernen
					$Tmp = StringReplace($Tmp, " ", "0"); Leerzeichen wieder in Nullen wandeln
				Case 1; Dezimal
					If $gZiffGr = 1 Then; Zifferngruppierung an? 
						$Tmp = StringReplace($Tmp, ".", "")
						$Tmp = f_AddPunkt($Tmp); dann Punkte setzen
					EndIf
			EndSwitch
			GUICtrlSetData($Speicher, $Tmp)
	EndSwitch
	ControlFocus("Rechner+", "", $Input)
EndFunc

Func f_ContrClick()
	Local $msg = @GUI_CtrlID
	Switch $msg
		Case $gaContr[0]; Back-Button
			$gLErg = ""; Letztes Ergebnis lschen
			Local $Tmp = GUICtrlRead($Input)
			If StringRight($Tmp, 1) = " " Then
				$Tmp = StringTrimRight($Tmp, 3)
			Else
				$Tmp = StringTrimRight($Tmp, 1)
			EndIf
			$Tmp = StringReplace($Tmp, ".", "")
			$Tmp = f_AddPunkt($Tmp)
			GUICtrlSetData($Input, $Tmp)
		Case $gaContr[1]; Clear-Button
			$gLErg = ""
			GUICtrlSetData($Input, "")
			GUICtrlSetState($Input, $GUI_FOCUS)
		Case $gaContr[3]; up-Button
			If $gZSys = 1 Then; Zahlensystem = Dezimal?
				If $gNachkomma < 15 Then; noch keine 15 Nachkommastellen?
					$gNachkomma += 1; um eins erhhen
					GUICtrlSetData($gaContr[2], $gNachkomma); Nachkommastellen anzeigen
					IniWrite("Rechner+.ini", "Nachkomma", "gNachkomma", $gNachkomma); Anzahl der Nachkommastellen speichern
					If $gLErg <> "" Then 
						$gCheck = 1
						f_GleichClick(); wenn letztes Ergebnis noch im Speicher, dann Nachkommastellen anpassen
					EndIf
				EndIf	
			EndIf
		Case $gaContr[4]; down-Button
			If $gZSys = 1 Then; Zahlensystem = Dezimal?
				If $gNachkomma > 0 Then
					$gNachkomma -= 1; um eins verringern
					GUICtrlSetData($gaContr[2], $gNachkomma); Nachkommastellen anzeigen
					IniWrite("Rechner+.ini", "Nachkomma", "gNachkomma", $gNachkomma); Anzahl der Nachkommastellen speichern
					If $gLErg <> "" Then 
						$gCheck = 1
						f_GleichClick(); wenn letztes Ergebnis noch im Speicher, dann Nachkommastellen anpassen
					EndIf
				EndIf
			EndIf
	EndSwitch
	ControlFocus("Rechner+", "", $Input)
EndFunc

Func f_OpClick()
	Local $msg = @GUI_CtrlID - $gaOp[0]
	Local $tmp = GUICtrlRead($Input)
	Local $op = ""
	$gErgN = 0
	$gLErg = ""; Letztes Ergebnis lschen
	Switch $gZSys
		Case 0; Beim Hexadezimalsystem nicht alle Operatoren zulassen
			If Not(($msg = 1) or ($msg = 3) or ($msg > 7)) Then
				$op = " " & StringMid($gOperators, $msg + 1, 1) & " "; Operator mit Leerzeichen einfgen
			EndIf
		Case 1; Dezimalsystem
			Switch $msg
				Case 0 To 7
					If $msg = 3 Then; Operator 3 ist das "," 
						If $tmp = "" Then; kein fhrender Term?
							$op = "0,"; dann eine zustzliche Null einfgen
						Else 
							If StringRight($tmp, 1) = " " Then; fhrender Operator?
								$op = "0,"; dann eine zustzliche Null einfgen
							Else
								$op = ","; sonst nur das Komma einfgen
							EndIf
						EndIf
					Else
						$op = " " & StringMid($gOperators,$msg + 1, 1) & " "; Operator mit Leerzeichen einfgen
					EndIf
				Case 8; x^2
					If ($tmp <> "") and (StringInStr($tmp, " ") = 0) Then; Nur eine Zahl vorhanden
						GUICtrlSetData($Input, $tmp & " ^ 2 ")
						f_GleichClick()
						$tmp = GUICtrlRead($Input)
					Else
						If StringRegExp(StringRight($tmp, 1), "[0-9]") Then $op = " ^ 2 "
					EndIf
				Case 9; Wurzel
					If ($tmp <> "") and (StringInStr($tmp, " ") = 0) Then; Nur eine Zahl vorhanden
						GUICtrlSetData($Input, "V" & $tmp)
						f_GleichClick()
						$tmp = GUICtrlRead($Input)
					EndIf
					If Not StringRegExp(StringRight($tmp, 1), "[0-9]") Then $op = "V"
				Case 10
					$op = "2 ^ "; [2^] Operator einfgen
				Case 11
					If $Tmp <> "" Then 
						$Tmp = f_AddPunkt($tmp, 1)
					EndIf
			EndSwitch
	EndSwitch
	GUICtrlSetData($Input, $tmp & $op)
	ControlFocus("Rechner+", "", $Input)
EndFunc

Func f_GleichClick()
	Local $ausw
	If $gCheck = 0 Then; $gCheck ist 1, wenn Nachkommastellen-Anzeige verndert wurde
		$ausw = GUICtrlRead($Input); sonst: Eingabe holen
		$gLErg = $ausw; und als letztes Ergebnis speichern
	Else
		$ausw = $gLErg; Nachkommastellen verndert, dann letztes Ergebnis nochmal benutzen
	EndIf
	$ausw = f_Auswertung($ausw)
	If Not @error Then; Max. Gre von 15 Stellen nicht berschritten?
		$ausw = StringReplace($ausw, ".", ",")
		If ($gZiffGr = 1) and ($gZSys = 1) Then $ausw = f_AddPunkt($ausw)
		GUICtrlSetData($Input, $ausw); dann anzeigen
	Else; sonst
		GUICtrlSetData($Input, "--- Ergebnis berschreitet die max. Gre ---"); Meldung ausgeben
	EndIf
	ControlFocus("Rechner+", "", $Input)
	$gCheck = 0
	$gErgN = 1
EndFunc

Func f_Auswertung($Str)
	Local $st, $pos, $err = 0
	Switch $gZSys
		Case 0; Hexadezimalzahlen
			Local $s = StringSplit($Str, " ")
			For $i = 1 To $s[0]
				If StringRegExp($s[$i], "[0-9ABCDEF]") = 1 Then; Wenn Hexdezimalzahl
					If StringLen($s[$i]) > 8 Then $err = 1
					$s[$i] = "0x" & $s[$i]; dann 0x voranstellen
				EndIf
			Next
			$Str = ""
			For $i = 1 To $s[0]
				$Str &= $s[$i]
			Next
		Case 1; Dezimalzahlen
			Local $s = StringSplit($Str, " ")
			For $i = 1 To $s[0]
				If StringLeft($s[$i],1) = "V" Then; Wenn Wurzel
					$s[$i] = StringReplace($s[$i], "V", "Sqrt("); dann umwandeln
					$s[$i] &= ")"
				EndIf
			Next
			$Str = ""
			For $i = 1 To $s[0]
				$Str &= $s[$i]
			Next
			$Str = StringReplace($Str, ".", ""); Punkte entfernen
			$Str = StringReplace($Str, ",", "."); Komma in Punkt umwandeln (wegen Execute)
			$Str = StringReplace($Str, "Pi", $Pi); Wert fr Pi eintragen
	EndSwitch
	If $Str <> "" Then $Str = Execute($Str); Ausrechnen lassen
	Switch $gZSys; -----------------------/\ /\ /\------------------------------------------------------------------------------------------keine Fehlermeldung bei berlauf !------------------
		Case 0; Hexadezimalzahlen 
			;MsgBox(0,"","str:"&$Str&" err:"&$err&" s:"&$s[0])
			If $err = 1 Then; wenn ein Term grer als 0xffffffff 
				$Str = 0
				SetError(1)
			Else; Ergebnis kleiner als berlauf
				$Str = Hex($Str)
				$Str = StringReplace($Str, "0", " "); Nullen in Leerzeichen umwandeln
				$Str = StringStripWS($Str, 1); fhrende Leerzeichen (Nullen) entfernen
				$Str = StringReplace($Str, " ", "0"); Leerzeichen wieder in Nullen wandeln
			EndIf
		Case 1; Dezimalzahlen
			If $Str < 1e+015 Then; wenn Ergebnis kleiner als berlauf
				$st = GUICtrlRead($gaContr[2]); Nachkommastellen holen
				$Str = Round($Str, $st); Ergebnis auf-/abrunden
				$pos = StringInStr($Str, "."); Position vom Dezimalpunkt
				If $pos <> 0 Then; Dezimalpunkt vorhanden? Dann Nachkommastellen (bei zu wenigen Stellen) bis zum eingestellten Wert mit Nullen auffllen
					$Str = StringLeft($Str, $pos) & StringLeft(StringMid($Str & "000000000000000", $pos+1), $st)
				EndIf
			Else; Ergebnis grer als berlauf
				$Str = 0
				SetError(1)
			EndIf
	EndSwitch
	$err = 0
	Return($Str)
EndFunc

Func f_DFUeSpeed()
	Local $msg = GUICtrlRead($gDSpeed)
	$gDFUeSpeed = StringTrimRight($msg, 7)
	$gDFUeSpeed = StringReplace($gDFUeSpeed, ".", ""); Punkte entfernen
	$gDFUeSpeed = StringStripWS($gDFUeSpeed, 1); fhrende Leerzeichen entfernen
	IniWrite("Rechner+.ini", "Download-Rechner", "gDFUeSpeed", Chr(34) & $msg & Chr(34)) 
	f_DFUeGleich()
EndFunc

Func f_DFUeEinheit()
	Local $msg = @GUI_CtrlID
	Switch $msg
		Case $gaFText2[2]; damit auch der Klick auf den Text funktioniert
			ControlFocus("Rechner+", "", $gaEinheit[0])
			ControlClick("Rechner+", "", $gaEinheit[0])
		Case $gaEinheit[0]; Einheit KByte ausgewhlt
			$gDFUeEinheit = 2^10
		Case $gaFText2[3]; damit auch der Klick auf den Text funktioniert
			ControlFocus("Rechner+", "", $gaEinheit[1])
			ControlClick("Rechner+", "", $gaEinheit[1])
		Case $gaEinheit[1]; Einheit MByte ausgewhlt
			$gDFUeEinheit = 2^20
		Case $gaFText2[4]; damit auch der Klick auf den Text funktioniert
			ControlFocus("Rechner+", "", $gaEinheit[2])
			ControlClick("Rechner+", "", $gaEinheit[2])
		Case $gaEinheit[2]; Einheit GByte ausgewhlt
			$gDFUeEinheit = 2^30
	EndSwitch
	IniWrite("Rechner+.ini", "Download-Rechner", "gDFUeEinheit", $gDFUeEinheit) 
	f_DFUeGleich()
EndFunc

Func f_DFUeGleich()
	If $gZSys = 1 Then
		Local $std, $min, $sek, $erg
		$erg = GUICtrlRead($Input); Eingabe holen
		$erg = Abs(f_Auswertung($erg)); Auswertung, falls nicht nur eine Zahl
		If Not @error Then
			$erg = ($erg * $gDFUeEinheit * 8) / ($gDFUeSpeed * 1000); Ergebnis in Sekunden
			$sek = Int(Mod($erg, 60))
			$min = Int(Mod(Int($erg / 60), 60))
			$std = Int($erg / 3600)
			If $std < 8760 Then 
				GUICtrlSetData($gaFText2[5], StringFormat("%2i Std. %02i Min. %02i Sek.", $std, $min, $sek))
			Else
				GUICtrlSetData($gaFText2[5], "mehr als 1 Jahr  :-) ")
			EndIf
		EndIf
	EndIf
EndFunc

Func f_DFUeKopieren()
	ClipPut(GUICtrlRead($gaFText2[5]))
EndFunc

Func f_ZwKopieren()
	ClipPut(GUICtrlRead($Input))
EndFunc

Func f_ZwEinfuegen()
	Local $clip = ClipGet()
	GUICtrlSetData($Input, GUICtrlRead($Input) & $clip)
EndFunc

Func f_ZiffGrClick()
	Switch $gZiffGr
		Case 0
			$gZiffGr = 1
			GUICtrlSetState($MenuZiffGr, $GUI_CHECKED)
			IniWrite("Rechner+.ini", "Zifferngruppierung", "gZiffGr", "1"); Zifferngruppierung (1 = an)
		Case 1
			$gZiffGr = 0
			GUICtrlSetState($MenuZiffGr, $GUI_UNCHECKED)
			IniWrite("Rechner+.ini", "Zifferngruppierung", "gZiffGr", "0"); Zifferngruppierung (0 = aus)
			EndSwitch
EndFunc

Func f_FHintergr()
	$gBGColor = _ChooseColor(2, "0x357682", 2); Hintergrundfarbe des Fensters auswhlen
	If $gBGColor <> "-1" Then; Wenn der Benutzer nicht auf [abbrechen] geklickt hat,
		GUISetBkColor($gBGColor, $gMain); dann Farbe setzen
		IniWrite("Rechner+.ini", "Color", "gBGColor", $gBGColor); und in Ini-Datei speichern
	EndIf
EndFunc

Func f_FText1()
	$gFText1 = _ChooseColor(2, "0xE6E6E6", 2); Text 1 Farbe auswhlen
	If $gFText1 <> "-1" Then; Wenn der Benutzer nicht auf [abbrechen] geklickt hat,
		For $i = 0 To 7
			GUICtrlSetColor($gaFText1[$i], $gFText1); dann Farbe setzen
		Next
		IniWrite("Rechner+.ini", "Color", "gFText1", $gFText1); und in Ini-Datei speichern
	EndIf
EndFunc

Func f_FText2()
	$gFText2 = _ChooseColor(2, "0xFFFF80", 2); Text 2 Farbe auswhlen
	If $gFText2 <> "-1" Then; Wenn der Benutzer nicht auf [abbrechen] geklickt hat,
		For $i = 0 To 9
			GUICtrlSetColor($gaFText2[$i], $gFText2); dann Farbe setzen
		Next
		GUICtrlSetColor($Speicher, $gFText2); dann Farbe setzen
		IniWrite("Rechner+.ini", "Color", "gFText2", $gFText2); und in Ini-Datei speichern
	EndIf
EndFunc

Func f_Vordergrund(); Wird im Men aufgerufen
	Switch $gOnTop; Immer im Vordergrund
		Case 0; vorher kein Haken,
			$gOnTop = 1; dann setzen,
			f_OnTop(1); Fenster anpassen
			IniWrite("Rechner+.ini", "OnTop", "gOnTop", "1"); und abspeichern
			Case 1; vorher Haken,
			$gOnTop = 0; dann lschen,
			f_OnTop(0); Fenster anpassen
			IniWrite("Rechner+.ini", "OnTop", "gOnTop", "0"); und abspeichern
	EndSwitch
EndFunc

Func f_OnTop($msg); Fenster immer im Vordergrund (Werte setzen)
	Switch $msg
		Case 0
			WinSetOnTop("Rechner+", "", 0)
			GUICtrlSetState($MenuOnTop, $GUI_UNCHECKED)
		Case 1
			WinSetOnTop("Rechner+", "", 1)
			GUICtrlSetState($MenuOnTop, $GUI_CHECKED)
	EndSwitch
EndFunc

Func f_WaehrungCombo()
	IniWrite("Rechner+.ini", "Waehrung", "von", Chr(34) & GUICtrlRead($gWaehrungVon) & Chr(34))
	IniWrite("Rechner+.ini", "Waehrung", "nach", Chr(34) & GUICtrlRead($gWaehrungNach) & Chr(34))
	f_WaehrungGleich()
EndFunc

Func f_WaehrungTauschen()
	Local $tmp = GUICtrlRead($gWaehrungVon)
	GUICtrlSetData($gWaehrungVon, GUICtrlRead($gWaehrungNach))
	GUICtrlSetData($gWaehrungNach, $tmp)
	f_WaehrungGleich()
EndFunc

Func f_WaehrungGleich()
	If $gZSys = 1 Then
		Local $erg, $von, $nach, $ivon, $inach
		$erg = GUICtrlRead($Input); Eingabe holen
		$erg = Abs(f_Auswertung($erg)); Auswertung, falls nicht nur eine Zahl
		If Not @error Then
			$von = StringMid(GUICtrlRead($gWaehrungVon),2)
			$nach = StringMid(GUICtrlRead($gWaehrungNach),2)
			For $i = 1 To $gaWaehrung[0][0]
				If $von = $gaWaehrung[$i][0] Then $ivon = $i
				If $nach = $gaWaehrung[$i][0] Then $inach = $i
			Next
			$erg = Round(($erg / $gaWaehrung[$ivon][1] * $gaWaehrung[$inach][1]),2)
			$erg = StringFormat("%.2f", $erg)
			$erg = StringReplace($erg, ".", ",")
			$erg = f_AddPunkt($erg)
			GUICtrlSetData($gaFText2[9], $erg & " " & GUICtrlRead($gWaehrungNach))
		EndIf
	EndIf
EndFunc

Func f_WaehrungHelp1()
	If WinGetState($gWHelp) <> 2 Then
		GUISetState(@SW_SHOW, $gWHelp)
		$gWHA = $gWaehrungVon
	EndIf
EndFunc

Func f_WaehrungHelp2()
	If WinGetState($gWHelp) <> 2 Then
		GUISetState(@SW_SHOW, $gWHelp)
		$gWHA = $gWaehrungNach
	EndIf
EndFunc

Func f_WOkClick()
	GUISetState(@SW_HIDE, $gWHelp)
	Local $msg = @GUI_CtrlID
	If ($msg < $WOk) and ($gWHA <> "") Then 
		GUICtrlSetData($gWHA, " " & $gaWaehrung[$msg-4][0])
		f_WaehrungCombo()
	EndIf
EndFunc

Func f_KursZeigen()
	If WinGetState($gWHelp) <> 2 Then
		GUISetState(@SW_SHOW, $gWHelp)
		$gWHA = ""
	EndIf
EndFunc

Func f_InfoClick()
	Local $Info = ""
	Local $var = IniReadSection("Rechner+.ini", "Info")
	If @error Then 
			MsgBox(0x40030, "", "Ini-Datei fehlt oder fehlerhaft.")
	Else
	    For $i = 1 To $var[0][0]
					$Info &= $var[$i][0] & ": " & $var[$i][1] & @CRLF
	    Next
	EndIf
	MsgBox(0x40040, "Rechner+", $Info)
EndFunc

Func f_HilfeClick()
	ShellExecute("Rechner+.chm")
EndFunc

Func f_HotKey()
	Local $msg = @HotKeyPressed
	Switch $msg
		Case "{NUMPAD0}"
			ControlClick("Rechner+", "", $gaZahl[0])
		Case "{NUMPAD1}"
			ControlClick("Rechner+", "", $gaZahl[1])
		Case "{NUMPAD2}"
			ControlClick("Rechner+", "", $gaZahl[2])
		Case "{NUMPAD3}"
			ControlClick("Rechner+", "", $gaZahl[3])
		Case "{NUMPAD4}"
			ControlClick("Rechner+", "", $gaZahl[4])
		Case "{NUMPAD5}"
			ControlClick("Rechner+", "", $gaZahl[5])
		Case "{NUMPAD6}"
			ControlClick("Rechner+", "", $gaZahl[6])
		Case "{NUMPAD7}"
			ControlClick("Rechner+", "", $gaZahl[7])
		Case "{NUMPAD8}"
			ControlClick("Rechner+", "", $gaZahl[8])
		Case "{NUMPAD9}"
			ControlClick("Rechner+", "", $gaZahl[9])
		Case "{ENTER}"
			ControlClick("Rechner+", "", $gGleich)
		Case "{NUMPADDIV}"
			ControlClick("Rechner+", "", $gaOp[0])
		Case "{NUMPADMULT}"
			ControlClick("Rechner+", "", $gaOp[2])
		Case "{NUMPADSUB}"
			ControlClick("Rechner+", "", $gaOp[4])
		Case "{NUMPADADD}"
			ControlClick("Rechner+", "", $gaOp[6])
		Case "{NUMPADDOT}"
			ControlClick("Rechner+", "", $gaOp[3])
		Case "{BACKSPACE}"
			ControlClick("Rechner+", "", $gaContr[0])
		Case "{DELETE}"
			ControlClick("Rechner+", "", $gaContr[1])
	EndSwitch
EndFunc

Func f_GUICreate()
;====================================================================================================================================================	
	$gWHelp = GUICreate("WHelp",420,500,-1,-1, BitOr($WS_POPUP, $WS_BORDER),BitOr($WS_EX_TOOLWINDOW, $WS_EX_TOPMOST))
	GUISetState(@SW_Hide, $gWHelp); Fenster erstmal verstecken
	GUICtrlCreateLabel("Whrungsdaten", 120, 10, 250, 25)
	GUICtrlSetFont(-1, 14, 800, 0, "Tahoma")
	$Liste = GUICtrlCreateListView("Abk. |Whrung |1 EUR = ", 10, 40, 400, 400)
	GUICtrlSetFont(-1, 9, 400, 0, "Courier New")
	If _FileReadToArray("waehrungsabk.txt", $gaWAbkHilfe) Then
		For $i = 1 To $gaWAbkHilfe[0]
			$tmp = $gaWaehrung[$i][1]
			If $tmp = Int($tmp) Then
				$tmp &= ".0000"
			Else
				$tmp &= "0000"
			EndIf
			$tmp = "       " & $tmp
			$pos = StringInStr($tmp, ".")
			$tmp = StringMid($tmp, $pos-7, 7) & StringMid($tmp, $pos, 5)
			GUICtrlCreateListViewItem($gaWAbkHilfe[$i] & "|" & $tmp, $Liste)
			GUICtrlSetOnEvent(-1, "f_WOkClick")
		Next
	EndIf
	_GUICtrlListView_SetColumnWidth($Liste, 0, 50)
	_GUICtrlListView_SetColumnWidth($Liste, 1, 220)
	_GUICtrlListView_SetColumnWidth($Liste, 2, 100)
	GUICtrlCreateLabel("zuletzt aktualisiert: ", 230, 445, 90, 25)
	GUICtrlSetFont(-1, 8, 400, 0, "Tahoma")
	$gWAktDatum = GUICtrlCreateLabel($gDatum, 320, 445, 120, 25)
	GUICtrlSetFont(-1, 8, 400, 0, "Tahoma")
	$WOk = GUICtrlCreateButton(" Ok ", 180, 470, 60, 20)
	GUICtrlSetOnEvent(-1, "f_WOkClick")
;====================================================================================================================================================	
	$gMain = GUICreate("Rechner+", 560, 500, -1, -1)
	GUISetOnEvent($GUI_EVENT_CLOSE, "f_MainClose")

	$gBGColor = IniRead("Rechner+.ini", "Color", "gBGColor", "0x408F9D")
	GUISetBkColor($gBGColor, $gMain)

	GUICtrlCreateGroup(" ", 10, 10, 540, 53)
		$gaFText1[0] = GUICtrlCreateLabel(" Eingabe && Ergebnis ", 20, 6, 123, 20, $DS_SETFOREGROUND)
		GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText1)
		$Input = GUICtrlCreateInput("", 15, 30, 530, 25, BitOR($ES_RIGHT,$ES_AUTOHSCROLL,$ES_READONLY))
		GUICtrlSetBkColor(-1, "0XFFFFFF")
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetOnEvent(-1, "f_GleichClick")
		GUICtrlSetState(-1, $GUI_FOCUS)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup(" ", 220, 75, 330, 45)
		$gaFText1[1] = GUICtrlCreateLabel(" Speicher ", 230, 71, 60, 20, $DS_SETFOREGROUND)
		GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText1)
		$Speicher = GUICtrlCreateLabel("0", 235, 93, 303, 25, $SS_RIGHT)
		GUICtrlSetColor(-1, $gFText2)
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup(" ", 10, 75, 200, 45)
		$gaFText1[2] = GUICtrlCreateLabel(" Zahlensystem ", 20, 71, 90, 20, $DS_SETFOREGROUND)
		GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText1)
		$gaZSys[0] = GUICtrlCreateRadio("", 20, 93, 14, 17)
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetOnEvent(-1, "f_ZSysClick")
		$gaFText2[0] = GUICtrlCreateLabel("Hexadezimal", 37, 93, 80, 22)
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText2)
		GUICtrlSetOnEvent(-1, "f_ZSysClick")
		$gaZSys[1] = GUICtrlCreateRadio("", 130, 93, 14, 17)
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetOnEvent(-1, "f_ZSysClick")
		GUICtrlSetState(-1, $GUI_CHECKED)
		$gaFText2[1] = GUICtrlCreateLabel("Dezimal", 147, 93, 60, 22)
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText2)
		GUICtrlSetOnEvent(-1, "f_ZSysClick")
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	
	GUICtrlCreateGroup("", 10, 130, 200, 180)
		$gaFText1[3] = GUICtrlCreateLabel(" Download-Rechner ", 20, 126, 120, 20, $DS_SETFOREGROUND)
		GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText1)
		$gDFUeSpeed = IniRead("Rechner+.ini", "Download-Rechner", "gDFUeSpeed", "  1.024 kBit/s")
		$gDSpeed = GUICtrlCreateCombo("", 60, 160, 140, 25, BitOR($CBS_DROPDOWNLIST,$CBS_AUTOHSCROLL))
		GUICtrlSetData(-1, "     56 kBit/s|     64 kBit/s|    128 kBit/s|    192 kBit/s|    256 kBit/s|    384 kBit/s|    512 kBit/s|    640 kBit/s|    768 kBit/s|  1.024 kBit/s|  2.048 kBit/s|  3.072 kBit/s|  4.096 kBit/s|  6.144 kBit/s| 16.000 kBit/s", $gDFUeSpeed)
		GUICtrlSetFont(-1, 10, 800, 0, "Courier New")
		GUICtrlSetOnEvent(-1, "f_DFUeSpeed")
		GUIStartGroup()
			$gaEinheit[0] = GUICtrlCreateRadio("", 20, 200, 14, 17)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetOnEvent(-1, "f_DFUeEinheit")
			$gaFText2[2] = GUICtrlCreateLabel("KByte", 35, 200, 45, 17)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetColor(-1, $gFText2)
			GUICtrlSetOnEvent(-1, "f_DFUeEinheit")
			$gaEinheit[1] = GUICtrlCreateRadio("", 82, 200, 14, 17)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetOnEvent(-1, "f_DFUeEinheit")
			$gaFText2[3] = GUICtrlCreateLabel("MByte", 97, 200, 45, 22)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetColor(-1, $gFText2)
			GUICtrlSetOnEvent(-1, "f_DFUeEinheit")
			$gaEinheit[2] = GUICtrlCreateRadio("", 146, 200, 14, 17)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetOnEvent(-1, "f_DFUeEinheit")
			$gaFText2[4] = GUICtrlCreateLabel("GByte", 161, 200, 45, 22)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetColor(-1, $gFText2)
			GUICtrlSetOnEvent(-1, "f_DFUeEinheit")
			$gDFUeEinheit = IniRead("Rechner+.ini", "Download-Rechner", "gDFUeEinheit", "1048576")
			Switch $gDFUeEinheit
				Case 2^10
					GUICtrlSetState($gaEinheit[0], $GUI_CHECKED)
				Case 2^20
					GUICtrlSetState($gaEinheit[1], $GUI_CHECKED)
				Case 2^30
					GUICtrlSetState($gaEinheit[2], $GUI_CHECKED)
			EndSwitch
		GUICtrlCreateGroup("", -99, -99, 1, 1)
		GUICtrlCreateGroup("", 20, 230, 180, 40)
			$gaFText1[4] = GUICtrlCreateLabel(" Download-Zeit ", 30, 226, 92, 20, $DS_SETFOREGROUND)
			GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
			GUICtrlSetColor(-1, $gFText1)
			$gaFText2[5] = GUICtrlCreateLabel("0", 25, 245, 170, 22, $SS_RIGHT)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetColor(-1, $gFText2)
			$conMenu = GUICtrlCreateContextMenu($gaFText2[5])
			$conMenuItem = GUICtrlCreateMenuitem("Kopieren", $conMenu)
			GUICtrlSetOnEvent(-1, "f_DFUeKopieren")
			$gDFUeGleich = GUICtrlCreateButton("", 70, 280, 90, 20, $BS_ICON)
			GUICtrlSetImage(-1, "gfx\e-berechnen.ico") 
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetOnEvent(-1, "f_DFUeGleich")
		GUICtrlCreateGroup("", -99, -99, 1, 1)
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("", 10, 320, 200, 152)
		$gaFText1[5] = GUICtrlCreateLabel(" Whrungs-Rechner ", 20, 316, 120, 20, $DS_SETFOREGROUND)
		GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText1)
		$gaFText2[6] = GUICtrlCreateLabel("von?", 27, 337, 50, 20)
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText2)
		GUICtrlSetCursor(-1, 4)
		GUICtrlSetOnEvent(-1, "f_WaehrungHelp1")
		$gaFText2[7] = GUICtrlCreateLabel("in?", 150, 337, 50, 20)
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText2)
		GUICtrlSetCursor(-1, 4)
		GUICtrlSetOnEvent(-1, "f_WaehrungHelp2")
		$InitVon = IniRead("Rechner+.ini", "Waehrung", "von", " EUR")
		$gWaehrungVon = GUICtrlCreateCombo("", 20, 355, 60, 20, BitOR($CBS_DROPDOWNLIST,$WS_VSCROLL))
		GUICtrlSetData(-1," EUR| AUD| BGN| BRL| CAD| CHF| CNY| CZK| DKK| GBP| HKD| HUF| IDR| INR| JPY| KRW| KWD| LKR| MXN| MYR| NOK| NZD| PHP| PKR| PLN| RUB| SAR| SEK| SGD| SKK| THB| TRY| TWD| USD| ZAR", $InitVon)
		GUICtrlSetTip(-1,"Von dieser Whrung...")
		GUICtrlSetOnEvent(-1, "f_WaehrungCombo")
		$gTausch = GUICtrlCreateButton("<=>", 90, 355, 40, 21, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-tauschen.ico") 
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetOnEvent(-1, "f_WaehrungTauschen")
		$InitNach = IniRead("Rechner+.ini", "Waehrung", "nach", " USD")
		$gWaehrungNach = GUICtrlCreateCombo("", 140, 355, 60, 20, BitOR($CBS_DROPDOWNLIST,$WS_VSCROLL))
		GUICtrlSetData(-1," EUR| AUD| BGN| BRL| CAD| CHF| CNY| CZK| DKK| GBP| HKD| HUF| IDR| INR| JPY| KRW| KWD| LKR| MXN| MYR| NOK| NZD| PHP| PKR| PLN| RUB| SAR| SEK| SGD| SKK| THB| TRY| TWD| USD| ZAR", $InitNach)
		GUICtrlSetTip(-1,"...in diese Whrung")
		GUICtrlSetOnEvent(-1, "f_WaehrungCombo")
		GUICtrlCreateGroup("", 20, 390, 180, 40)
			$gaFText1[6] = GUICtrlCreateLabel(" Ergebnis ", 30, 385, 60, 20, $DS_SETFOREGROUND)
			GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
			GUICtrlSetColor(-1, $gFText1)
			$gaFText2[9] = GUICtrlCreateLabel("0,00 " & GUICtrlRead($gWaehrungNach), 25, 405, 168, 22, $SS_RIGHT)
			GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
			GUICtrlSetColor(-1, $gFText2)
		GUICtrlCreateGroup("", -99, -99, 1, 1)
		$gWaehrungGleich = GUICtrlCreateButton("umrechnen", 70, 440, 90, 20, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-umrechnen.ico") 
		GUICtrlSetFont(-1, 10, 800, 0, "Tahoma")
		GUICtrlSetOnEvent(-1, "f_WaehrungGleich")
	GUICtrlCreateGroup("", -99, -99, 1, 1)

	GUICtrlCreateGroup("", 220, 130, 330, 342); Tastenfeldgruppe <Anfang>
		$gaFText1[7] = GUICtrlCreateLabel(" Tastatur ", 230, 126, 60, 20, $DS_SETFOREGROUND)
		GUICtrlSetFont(-1, 10, 400, 0, "Tahoma")
		GUICtrlSetColor(-1, $gFText1)
		$gaContr[0] = GUICtrlCreateButton("<-", 230, 150, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-back.ico") 
		GUICtrlSetOnEvent(-1, "f_ContrClick")
		$gaContr[1] = GUICtrlCreateButton("C", 295, 150, 128, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-clear.ico") 
		GUICtrlSetOnEvent(-1, "f_ContrClick")
		$gaContr[2] = GUICtrlCreateInput($gNachkomma, 435, 150, 86, 37, BitOR($ES_CENTER,$ES_READONLY,$WS_BORDER))
		GUICtrlSetFont(-1, 20, 400, 0, "Tahoma")
		GUICtrlSetBKColor(-1, "0XFFFFFF")
		GUICtrlSetTip(-1,"Anzahl der Nachkommastellen" & @CRLF & "(Ergebnis wird auf- bzw. abgerundet)")
		$gaContr[3] = GUICtrlCreateButton("", 522, 151, 17, 18, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-up.ico") 
		GUICtrlSetOnEvent(-1, "f_ContrClick")
		$gaContr[4] = GUICtrlCreateButton("", 522, 169, 17, 18, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-down.ico") 
		GUICtrlSetOnEvent(-1, "f_ContrClick")
		
		$gaMem[0] = GUICtrlCreateButton("MC", 230, 195, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-mc.ico") 
		GUICtrlSetOnEvent(-1, "f_MemClick")
		$gaMem[1] = GUICtrlCreateButton("MR", 230, 240, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-mr.ico") 
		GUICtrlSetOnEvent(-1, "f_MemClick")
		$gaMem[2] = GUICtrlCreateButton("M-", 230, 285, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-m-.ico") 
		GUICtrlSetOnEvent(-1, "f_MemClick")
		$gaMem[3] = GUICtrlCreateButton("M+", 230, 330, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-m+.ico") 
		GUICtrlSetOnEvent(-1, "f_MemClick")
		
		$gaZahl[0] = GUICtrlCreateButton("0", 295, 330, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-0.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[1] = GUICtrlCreateButton("1", 295, 285, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-1.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[2] = GUICtrlCreateButton("2", 340, 285, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-2.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[3] = GUICtrlCreateButton("3", 385, 285, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-3.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[4] = GUICtrlCreateButton("4", 295, 240, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-4.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[5] = GUICtrlCreateButton("5", 340, 240, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-5.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[6] = GUICtrlCreateButton("6", 385, 240, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-6.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[7] = GUICtrlCreateButton("7", 295, 195, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-7.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[8] = GUICtrlCreateButton("8", 340, 195, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-8.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[9] = GUICtrlCreateButton("9", 385, 195, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-9.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[10] = GUICtrlCreateButton("Pi", 230, 375, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-10.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		
		$gaOp[0] = GUICtrlCreateButton("/", 435, 195, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op0.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[1] = GUICtrlCreateButton("^", 490, 195, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op1.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[2] = GUICtrlCreateButton("*", 435, 240, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op2.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[3] = GUICtrlCreateButton(",", 340, 330, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op3.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[4] = GUICtrlCreateButton("-", 435, 285, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op4.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[5] = GUICtrlCreateButton("(", 435, 375, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op5.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[6] = GUICtrlCreateButton("+", 435, 330, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op6.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[7] = GUICtrlCreateButton(")", 490, 375, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op7.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[8] = GUICtrlCreateButton("x", 490, 285, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op8.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[9] = GUICtrlCreateButton("  ", 490, 330, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op9.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[10] = GUICtrlCreateButton("2^x", 490, 240, 49, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op10.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		$gaOp[11] = GUICtrlCreateButton("+/-", 385, 330, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-op11.ico") 
		GUICtrlSetOnEvent(-1, "f_OpClick")
		
		$gGleich = GUICtrlCreateButton("=", 295, 375, 128, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-gleich.ico") 
		GUICtrlSetOnEvent(-1, "f_GleichClick")
		
		$gaZahl[11] = GUICtrlCreateButton("A", 230, 425, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-11.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[12] = GUICtrlCreateButton("B", 284, 425, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-12.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[13] = GUICtrlCreateButton("C", 338, 425, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-13.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[14] = GUICtrlCreateButton("D", 393, 425, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-14.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[15] = GUICtrlCreateButton("E", 447, 425, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-15.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
		$gaZahl[16] = GUICtrlCreateButton("F", 502, 425, 37, 37, $BS_ICON)
		GUICtrlSetImage(-1, "gfx\e-16.ico") 
		GUICtrlSetOnEvent(-1, "f_ZahlClick")
	GUICtrlCreateGroup("", -99, -99, 1, 1); Tastenfeldgruppe <Ende>

	Global $Menu0 = GUICtrlCreateMenu("Programm")
	Global $MenuItem1 = GUICtrlCreateMenuItem("Beenden", $Menu0, 0)
	GUICtrlSetOnEvent(-1, "f_MainClose")
	
	Global $Menu1 = GUICtrlCreateMenu("Bearbeiten")
	Global $MenuKop = GUICtrlCreateMenuItem("Kopieren", $Menu1, 0)
	GUICtrlSetOnEvent(-1, "f_ZwKopieren")
	Global $MenuEin = GUICtrlCreateMenuItem("Einfgen", $Menu1, 1)
	GUICtrlSetOnEvent(-1, "f_ZwEinfuegen")

	Global $Menu2 = GUICtrlCreateMenu("Ansicht")
	Global $MenuZiffGr = GUICtrlCreateMenuItem("Zifferngruppierung", $Menu2, 1)
	GUICtrlSetOnEvent(-1, "f_ZiffGrClick")
	If $gZiffGr = 1 Then GUICtrlSetState(-1, $GUI_CHECKED)
	Global $MenuOnTop = GUICtrlCreateMenuItem("Immer im Vordergrund", $Menu2, 2)
	GUICtrlSetOnEvent(-1, "f_Vordergrund")
	If $gOnTop = 1 Then GUICtrlSetState(-1, $GUI_CHECKED)
	Global $Separator = GUICtrlCreateMenuItem("", $Menu2, 3)
	Global $MenuBGColor = GUICtrlCreateMenuItem("Hintergrundfarbe auswhlen", $Menu2, 4)
	GUICtrlSetOnEvent(-1, "f_FHintergr")
	Global $MenuBGColor = GUICtrlCreateMenuItem("Textfarbe 1 auswhlen", $Menu2, 5)
	GUICtrlSetOnEvent(-1, "f_FText1")
	Global $MenuBGColor = GUICtrlCreateMenuItem("Textfarbe 2 auswhlen", $Menu2, 6)
	GUICtrlSetOnEvent(-1, "f_FText2")

	Global $Menu3 = GUICtrlCreateMenu("Whrung")
	Global $MenuWZe = GUICtrlCreateMenuItem("Umrechnungsdaten anzeigen", $Menu3, 0)
	GUICtrlSetOnEvent(-1, "f_KursZeigen")

	Global $Menu4 = GUICtrlCreateMenu("?")
	Global $MenuHilfe = GUICtrlCreateMenuItem("Hilfe", $Menu4, 0)
	GUICtrlSetOnEvent(-1, "f_HilfeClick")
	Global $Separator = GUICtrlCreateMenuItem("", $Menu4, 1)
	Global $MenuInfo = GUICtrlCreateMenuItem("Info", $Menu4, 2)
	GUICtrlSetOnEvent(-1, "f_InfoClick")
EndFunc

